#!/bin/bash
# BUG#501: whiteouts created in wrong directory on "mv dir .."

source scaffold

function files {
cat <<FILES
d $LOWER_DIR
d $LOWER_DIR/b0
d $LOWER_DIR/b1
d $LOWER_DIR/b1/a
FILES
}

function beforefiles {
echo $Type $LOWER_DIR/b1/a/b
}

afterfiles_whiteout_ro()
{
beforefiles
cat <<FILES
d $LOWER_DIR/b0/a
f $LOWER_DIR/b0/a/.wh.b
$Type $LOWER_DIR/b0/b
FILES
}
afterfiles_whiteout_rw()
{
	echo $Type $LOWER_DIR/b1/b
}
afterfiles_all_ro()
{
	afterfiles_whiteout_ro
	test $Type = d && echo f $LOWER_DIR/b0/b/.wh.__dir_opaque
}
afterfiles_all_rw()
{
	afterfiles_whiteout_rw
}

f() # delete_mode branch_mode
{
	echo -n '['$Type $@'] '
	{ files; beforefiles; } | create_hierarchy
	mount_union "delete=$1" $LOWER_DIR/b0 $LOWER_DIR/b1=$2
	cd $MOUNTPOINT/a
	mv b ..
	cd $OLDPWD
	unmount_union
	{ files ; afterfiles_${1}_$2; }  | check_hierarchy $LOWER_DIR
}

delete_mode=whiteout
test "$DELETE_ALL" -a ! "$DELETE_ALL" = "0" && delete_mode="$delete_mode all"
for i in $delete_mode
do
	for j in ro rw
	do
		for Type in f d
		do f $i $j
		done
	done
done

complete_test
